from gi.repository import Gtk
from gi.repository import WebKit


def __destroy_cb(widget, data=None):
    Gtk.main_quit()


def __progress_change_cb(download, something):
    progress = download.get_progress()
    print progress


def __state_change_cb(download, gparamspec):
    state = download.get_status()
    if state == WebKit.DownloadStatus.STARTED:
        print 'STARTED'
    elif state == WebKit.DownloadStatus.FINISHED:
        print 'FINISHED'
    elif state == WebKit.DownloadStatus.CANCELLED:
        print 'CANCELLED'
    else:
        print 'Other state: %s' % state


def __error_cb(download, err_code, err_detail, reason):
    print 'Error downloading URI code %s, detail %s: %s' % (err_code, err_detail, reason)


# We need to keep the download in memory
download = None
def __clicked_button(widget):
    print 'Button clicked'

    url = 'http://mkaufmann.com.ar/~humitos/olpc/audio/02%20-%20A%20veces%20no.mp3'
    # url = 'http://mkaufmann.com.ar/~humitos/olpc/audio/Example.ogg'
    nr = WebKit.NetworkRequest()
    nr.set_uri(url)
    global download
    download = WebKit.Download(network_request=nr)

    download.connect('notify::progress', __progress_change_cb)
    download.connect('notify::status', __state_change_cb)
    download.connect('error', __error_cb)

    print download.get_uri()
    download.set_destination_uri('file:///tmp/new_file.mp3')
    download.start()


window = Gtk.Window()
window.set_title('Download a file with WebKit example')
window.set_default_size(300, 180)
window.connect('destroy', __destroy_cb)

button = Gtk.Button('Download file!')
button.connect('clicked', __clicked_button)

window.add(button)
window.show_all()
Gtk.main()

